from __future__ import annotations
import sys
from importlib.machinery import ModuleSpec, PathFinder
from importlib.machinery import all_suffixes as module_suffixes
from importlib.util import spec_from_file_location
from itertools import chain
from pathlib import Path

MAPPING: dict[str, str] = {'raga': '/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga'}
NAMESPACES: dict[str, list[str]] = {'raga.docs': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/docs'], 'raga.env': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/env'], 'raga.validators': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/validators'], 'raga.env.bin': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/env/bin'], 'raga.env.include': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/env/include'], 'raga.env.lib': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/env/lib'], 'raga.examples.llm': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/llm'], 'raga.examples.llm.trace': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/llm/trace'], 'raga.examples.tests.data_leakage': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/data_leakage'], 'raga.examples.tests.fma_semantic_geopspatial': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/fma_semantic_geopspatial'], 'raga.examples.tests.active_learning_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/active_learning_tests'], 'raga.examples.tests.llm_performance': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/llm_performance'], 'raga.examples.tests.honeywell_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/honeywell_tests'], 'raga.examples.tests.ai_dash_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/ai_dash_tests'], 'raga.examples.tests.stress_test': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/stress_test'], 'raga.examples.tests.super_resolution': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/super_resolution'], 'raga.examples.tests.lightmetrics_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/lightmetrics_tests'], 'raga.examples.tests.llm_guardrail_test': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/llm_guardrail_test'], 'raga.examples.tests.model_serving': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/model_serving'], 'raga.examples.tests.fma': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/fma'], 'raga.examples.tests.image_property_drift': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/image_property_drift'], 'raga.examples.tests.data_augmentation': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/data_augmentation'], 'raga.examples.tests.spatio_temporal_drift': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/spatio_temporal_drift'], 'raga.examples.tests.policy_bazaar_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/policy_bazaar_tests'], 'raga.examples.tests.scenario_imbalance': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/scenario_imbalance'], 'raga.examples.tests.entropy_analysis': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/entropy_analysis'], 'raga.examples.tests.drift_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/drift_tests'], 'raga.examples.tests.labelling_qc_score_df': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/labelling_qc_score_df'], 'raga.examples.tests.ab_test': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/ab_test'], 'raga.examples.tests.keypoint_detection_test': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/keypoint_detection_test'], 'raga.examples.tests.label_drift_detection_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/label_drift_detection_tests'], 'raga.examples.tests.walmart_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/walmart_tests'], 'raga.examples.tests.class_imbalance_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/class_imbalance_tests'], 'raga.examples.tests.labelling_quality': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/labelling_quality'], 'raga.examples.tests.semantic_similarity_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/semantic_similarity_tests'], 'raga.examples.tests.nanonet_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/nanonet_tests'], 'raga.examples.tests.automobile_self_serve_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/automobile_self_serve_tests'], 'raga.examples.tests.fma_keypoint_detection': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/fma_keypoint_detection'], 'raga.examples.tests.satsure_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/satsure_tests'], 'raga.examples.tests.fma_structured_data': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/fma_structured_data'], 'raga.examples.tests.near_duplicate_tests': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/tests/near_duplicate_tests'], 'raga.examples.data_loaders.keypoint_detection_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/keypoint_detection_data_loader'], 'raga.examples.data_loaders.ai_dash_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/ai_dash_data_loader'], 'raga.examples.data_loaders.lightmetrics_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/lightmetrics_data_loader'], 'raga.examples.data_loaders.llm_performance_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/llm_performance_loader'], 'raga.examples.data_loaders.automobile_self_serve_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/automobile_self_serve_data_loader'], 'raga.examples.data_loaders.satsure_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/satsure_data_loader'], 'raga.examples.data_loaders.fma_semantic_geospatial_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/fma_semantic_geospatial_loader'], 'raga.examples.data_loaders.fma_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/fma_loader'], 'raga.examples.data_loaders.super_resolution': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/super_resolution'], 'raga.examples.data_loaders.scenario_imbalance_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/scenario_imbalance_loader'], 'raga.examples.data_loaders.nearest_neighbour_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/nearest_neighbour_loader'], 'raga.examples.data_loaders.label_drift_detection_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/label_drift_detection_data_loader'], 'raga.examples.data_loaders.policy_bazaar_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/policy_bazaar_loader'], 'raga.examples.data_loaders.image_property_drift': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/image_property_drift'], 'raga.examples.data_loaders.data_augmentation': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/data_augmentation'], 'raga.examples.data_loaders.self_serve_data_loaders': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/self_serve_data_loaders'], 'raga.examples.data_loaders.OD_Philips': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/OD_Philips'], 'raga.examples.data_loaders.spatio_temporal_drift': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/spatio_temporal_drift'], 'raga.examples.data_loaders.data_drift_llm': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/data_drift_llm'], 'raga.examples.data_loaders.guardrail_test_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/guardrail_test_data_loader'], 'raga.examples.data_loaders.lq_object_detection_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/lq_object_detection_data_loader'], 'raga.examples.data_loaders.data_leakage_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/data_leakage_loader'], 'raga.examples.data_loaders.nanonet_data_loaders': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/nanonet_data_loaders'], 'raga.examples.data_loaders.labelling_qc_score_df': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/labelling_qc_score_df'], 'raga.examples.data_loaders.entropy_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/entropy_loader'], 'raga.examples.data_loaders.IC_Philips': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/IC_Philips'], 'raga.examples.data_loaders.lq_keypoint_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/lq_keypoint_data_loader'], 'raga.examples.data_loaders.active_learning_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/active_learning_loader'], 'raga.examples.data_loaders.semantic_similarity_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/semantic_similarity_loader'], 'raga.examples.data_loaders.fma_keypoint_detections_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/fma_keypoint_detections_data_loader'], 'raga.examples.data_loaders.lq_instance_segmentation_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/lq_instance_segmentation_loader'], 'raga.examples.data_loaders.keypoint_self_serve': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/keypoint_self_serve'], 'raga.examples.data_loaders.honeywell_data_loader': ['/Users/ragaai_user/Documents/raga/testing-platform-python-client/raga/examples/data_loaders/honeywell_data_loader']}
PATH_PLACEHOLDER = '__editable__.raga_testing_platform-1.1.66.finder' + ".__path_hook__"


class _EditableFinder:  # MetaPathFinder
    @classmethod
    def find_spec(cls, fullname: str, _path=None, _target=None) -> ModuleSpec | None:
        # Top-level packages and modules (we know these exist in the FS)
        if fullname in MAPPING:
            pkg_path = MAPPING[fullname]
            return cls._find_spec(fullname, Path(pkg_path))

        # Handle immediate children modules (required for namespaces to work)
        # To avoid problems with case sensitivity in the file system we delegate
        # to the importlib.machinery implementation.
        parent, _, child = fullname.rpartition(".")
        if parent and parent in MAPPING:
            return PathFinder.find_spec(fullname, path=[MAPPING[parent]])

        # Other levels of nesting should be handled automatically by importlib
        # using the parent path.
        return None

    @classmethod
    def _find_spec(cls, fullname: str, candidate_path: Path) -> ModuleSpec | None:
        init = candidate_path / "__init__.py"
        candidates = (candidate_path.with_suffix(x) for x in module_suffixes())
        for candidate in chain([init], candidates):
            if candidate.exists():
                return spec_from_file_location(fullname, candidate)
        return None


class _EditableNamespaceFinder:  # PathEntryFinder
    @classmethod
    def _path_hook(cls, path) -> type[_EditableNamespaceFinder]:
        if path == PATH_PLACEHOLDER:
            return cls
        raise ImportError

    @classmethod
    def _paths(cls, fullname: str) -> list[str]:
        paths = NAMESPACES[fullname]
        if not paths and fullname in MAPPING:
            paths = [MAPPING[fullname]]
        # Always add placeholder, for 2 reasons:
        # 1. __path__ cannot be empty for the spec to be considered namespace.
        # 2. In the case of nested namespaces, we need to force
        #    import machinery to query _EditableNamespaceFinder again.
        return [*paths, PATH_PLACEHOLDER]

    @classmethod
    def find_spec(cls, fullname: str, _target=None) -> ModuleSpec | None:
        if fullname in NAMESPACES:
            spec = ModuleSpec(fullname, None, is_package=True)
            spec.submodule_search_locations = cls._paths(fullname)
            return spec
        return None

    @classmethod
    def find_module(cls, _fullname) -> None:
        return None


def install():
    if not any(finder == _EditableFinder for finder in sys.meta_path):
        sys.meta_path.append(_EditableFinder)

    if not NAMESPACES:
        return

    if not any(hook == _EditableNamespaceFinder._path_hook for hook in sys.path_hooks):
        # PathEntryFinder is needed to create NamespaceSpec without private APIS
        sys.path_hooks.append(_EditableNamespaceFinder._path_hook)
    if PATH_PLACEHOLDER not in sys.path:
        sys.path.append(PATH_PLACEHOLDER)  # Used just to trigger the path hook
